// ==UserScript==
// @name MyPermissionsContent
// @include http://192.168.56.101:8888/cleaner*
// @include https://mypermissions.com/cleaner*
// @include http://192.168.56.101:8888/developers*
// @include https://mypermissions.com/developers*
// @require jquery-1.8.3.js
// ==/UserScript==

var mypermissions_content = null;

var extensionType = null;
var ua = window.navigator.userAgent;
if (ua.search(/Chrome/g) > -1) {
	extensionType = "chrome";
} else if (ua.search(/Opera/g) > -1) {
	extensionType = "opera";
} else if (ua.search(/Firefox/g) > -1) {
	extensionType = "firefox";
} else if (ua.search(/Safari/g) > -1) {
	extensionType = "safari";
}

function MyPermissionsContent() {
	var self = this;
	mypermissions_content = self;
}

MyPermissionsContent.prototype = {
	_setValueAsHiddenField : function(fieldName, value) {
        	var input = $("#" + fieldName);
			if (input.length == 0) {
				var input = $("<input id='" + fieldName + "' type='hidden' name='" + fieldName + "' value='' />");
				$("body").append(input);
			}

			if (value == null) { 
				value = "";
			}

			input.attr("value", value);
	},

	getInstallId : function(cb) {
		var self = this;
		kango.invokeAsync("mypermissions_user.getInstallId", function(val) {
			self._setValueAsHiddenField("myp_iid", val);

			if (cb) {
				cb();
			}
		});
	},

	setToken : function(token, cb) {
		var self = this;
		kango.invokeAsync('mypermissions_user.setToken', token, function(val) {
			self._setValueAsHiddenField("myp_token", token);

			if (cb) {
				cb();
			}
		});
	},

	getToken : function(cb) {
		var self = this;
		kango.invokeAsync('mypermissions_user.getToken', function(val) {
			self._setValueAsHiddenField("myp_token", val);
			if (cb) {
				cb(val);
			}
		});	
	},

	getVersion : function(cb) {
		var self = this;
		kango.invokeAsync('mypermissionscleanerextension.getVersion', function(val) {
			self._setValueAsHiddenField("myp_ver", val);
			if (cb) {
				cb(val);
			}
		});		
	},

	getActiveFacebookUser : function() {
		var self = this;
		kango.invokeAsync("mypermissions_facebookcheck.getActiveFacebookUserDetails", function(data) {
			self._setValueAsHiddenField("myp_fb_a_uid", data.userId);
			self._setValueAsHiddenField("myp_fb_a_uname", data.name);
			self._setValueAsHiddenField("myp_fb_a_uico", data.icon);
		});
	},

	fetchActiveFacebookUser : function() {
		var self = this;
		kango.invokeAsync("mypermissions_facebookcheck.fetchFacebookUserDetails");
	},

	setLoginState : function(value) {
		kango.invokeAsync("mypermissions_facebookcheck.setLoginState", value);
	},

	startScan : function(reportProgress) {
		var t = $("#myp_token").val();

		if (t) {
			$.ajax({
				type : "POST",
				dataType: "json",
				url : "/api/v1/validate",
				data : { token : t },
				success: function(data, textStatus, jqXHR) {
					kango.invokeAsync("mypermissions_facebookcheck.check", reportProgress);
				},
				error : function(jqXHR, textStatus, errorThrown) {
					window.location.replace("/signin?et=" + extensionType);
				}
			});
		} else {
			kango.invokeAsync("mypermissions_facebookcheck.check", reportProgress);
		}
	},

	getApps : function() {
		var self = this;
		kango.invokeAsync("mypermissions_facebookcheck.getActiveUserId", function(fbActiveUserId) {
			kango.invokeAsync("mypermissions_facebookcheck._getAppsAsString", fbActiveUserId, function(data) {
				self._setValueAsHiddenField("myp_apps", data);
			});
		});		
	},

	retrieveServicesAllTrustedApps : function() {
		kango.invokeAsync("mypermissions_facebookcheck.getAllTrustedApps");
		kango.invokeAsync("mypermissions_facebookcheck.getUserTrustedApps");
	},

	saveApps : function(apps) {
		kango.invokeAsync("mypermissions_facebookcheck.saveAppsFromString", apps);
	},

	removeApp : function(appId) {
		kango.invokeAsync("mypermissions_facebookcheck.removeApp", appId);	
	},

	scanDeveloperApps : function() {
		kango.invokeAsync("mypermissions_developers.scanDeveloperApps");
	},

	facebookSignOut : function() {
		kango.invokeAsync("mypermissions_facebookcheck.signOut");	
	},

	initiateSingleAutoCheck : function() {
		kango.invokeAsync("mypermissions_facebookcheck.initiateSingleAutoCheck");
	},

	clearActiveScan : function() {
		kango.invokeAsync("mypermissions_facebookcheck.clearActiveScan");
	},

	setActiveScan : function(value) {
		kango.invokeAsync("mypermissions_facebookcheck.setActiveScan", value);
	}
}

function getDispatchCommand() {
	var tempValue = $("#myp_cc").val();
	if (tempValue != null && tempValue != "") {	
		$("#myp_cc").val("");

		return tempValue;
	}
}

function dispatch() {
	var cmd = getDispatchCommand();
	if (cmd && cmd != "") {
		var params = cmd.split(":");

		switch (params[0]) {
			case "getToken":
				mypermissions_content.getToken();
				break;
			case "fetchActiveFacebookUser":
				mypermissions_content.fetchActiveFacebookUser();
				break;
			case "setLoginState":
				mypermissions_content.setLoginState(params[1]);
				break;
			case "setToken":
				mypermissions_content.setToken(params[1]);
				break;
			case "startScan":
				var reportProgress = false;
				if (params[1] == "true") {
					reportProgress = true;
				}
				mypermissions_content.startScan(reportProgress);
				break;
			case "initiateSingleAutoCheck":
				mypermissions_content.initiateSingleAutoCheck();
				break;
			case "getApps":
				mypermissions_content.getApps();
				break;
			case "retrieveServicesAllTrustedApps":
				mypermissions_content.retrieveServicesAllTrustedApps();
				break;
			case "saveApps":								
				mypermissions_content.saveApps(unescape(params[1]));
				break;
			case "removeApp":
				mypermissions_content.removeApp(params[1]);
				break;
			case "facebookSignOut":
				mypermissions_content.facebookSignOut();
				break;
			case "clearActiveScan":
				mypermissions_content.clearActiveScan();
				break;
			case "setActiveScan":
				var value = (params[1] == "1");
				mypermissions_content.setActiveScan(value);
				break;
			case "scanDeveloperApps":				
				mypermissions_content.scanDeveloperApps();
				break;
			default:
				break;
		}
	}
}

var $ = window.$.noConflict(true); 

mypermissions_content = new MyPermissionsContent();

mypermissions_content.getToken(); 
mypermissions_content.getVersion();
mypermissions_content.getInstallId();

//mypermissions_content.getActiveFacebookUser();	

kango.addMessageListener('MyPermissionsUrlChange', function(event) {		

});

kango.addMessageListener('MyPermissionsFacebookUserDetails', function(event) {
	var data = event.data;
	mypermissions_content._setValueAsHiddenField("myp_fb_a_uid", data.userId);
	mypermissions_content._setValueAsHiddenField("myp_fb_a_uname", data.name);
	mypermissions_content._setValueAsHiddenField("myp_fb_a_uico", data.icon);
});

kango.addMessageListener('MyPermissionsFacebookSignOut', function(event) {
	mypermissions_content._setValueAsHiddenField("myp_fb_signout", event.data);
});

kango.addMessageListener('MyPermissionsScanProgress', function(event) {		
	if (window.location.hash && window.location.hash.indexOf("#!/scan") == 0) {
		var scanProgress = $("#myp_scan_progress");
		if (scanProgress.length == 0) {
			scanProgress = $("<input type='hidden' id='myp_scan_progress' name='myp_scan_progress', value=''/>");
			$("body").append(scanProgress);
		}

		scanProgress.val(event.data);
	}
});

kango.addMessageListener("MyPermissionsAppDeleted", function(event) {
	var data = JSON.parse(event.data);

	var fieldName = "myp_remove_confirm";
	var value = data.service + ":" + data.appId;
	var input = $("#" + fieldName);
	if (input.length == 0) {
		var input = $("<input id='" + fieldName + "' type='hidden' name='" + fieldName + "' value='' />");
		$("body").append(input);
	}

	if (value == null) { 
		value = "";
	}

	input.attr("value", value);		
});

kango.addMessageListener("MyPermissionsDeveloperAppsScanned", function(event) {
	if ($("#devApps").length == 0) {
		$("body").append($("<input type='hidden' id='devApps' value='' />"));
	}

	$("#devApps").val(event.data);
});

var extensionMarker = $("<input type='hidden' id='myp_mark' name='myp_mark' value='1' />");
$("body").append(extensionMarker);

// Start the dispatch interval loop
setInterval(function() {		
	dispatch();
}, 200);

kango.invokeAsync("mypermissions_facebookcheck.clearNewApps");
kango.invokeAsync("kango.ui.browserButton.setBadgeValue", "");

