mypermissions_facebookcheck = null;

function MyPermissions_FacebookCheck() {
	var self = this;

	mypermissions_facebookcheck = self;

	self.fetchFacebookUserDetails();
	self.getAllTrustedApps();
	self.getUserTrustedApps(function(data) {
		mypermissions_facebookcheck.startAutoCheck();
	}, null);

	self.fetchFacebookUserDetails();
}

MyPermissions_FacebookCheck.prototype = {
	name : "Facebook", 

	_currentTab : null,
	_autoCheckIntervalId : null,
	_lastAutoCheckTime : null,
	_lastManualCheckTime : null,

	_inTheMiddleOfChecking : false,

	_rootUrl : "https://m.facebook.com?locale=en_US",
	_settingsUrl : "https://m.facebook.com/privacy/applications.php?view=apps",
	_singleAppUrlTemplate : "https://m.facebook.com/privacy/applications.php?view=edapp&locale=en_US&id=",
	_removeUrlTemplate : "https://m.facebook.com/privacy/applications.php?view=remove&id=",

	_trustedApps : null,
	_trustedAppsIndex : new Array(),
	_userTrustedApps : null,
	_userTrustedAppsIndex : new Array(),

	isFirstTime : function() {
		var t = kango.storage.getItem("fb_firstTime");
		if (t && t != "") {
			return false;
		} 

		return true;
	},

	_setIsFirstTime : function(value) {
		kango.storage.setItem("fb_firstTime", value);
	},

	getLoginState : function() {
		return kango.storage.getItem("fb_active_login_state");
	},

	setLoginState : function(value) {
		kango.storage.setItem("fb_active_login_state", value);	
	},

	getAllTrustedApps : function(scb, fcb) {
 		var details = {
	    	url: mypermissions_urls.getAPIUrl("alltrustedapps"),
			method: 'GET',
			async: true,
			contentType: 'json',
			headers : { "X-Token" : mypermissions_user.getToken() }
	    }

	    var self = this;
	    kango.xhr.send(details, function(data) {
	    	if(data.status == 200 && data.response != null) {
	    		var result = data.response;
				self._trustedApps = result.data;
				for (var i in self._trustedApps) {
					var ta = self._trustedApps[i];
					self._trustedAppsIndex[ta.appId] = ta;
				}

				if (scb) {
					scb();
				}
	    	} else {
	    		if (scb) {
	    			scb(); // TODO: Consider handling failed cases better even though we don't require the token now
	    		}
	    	}
	    });
  	},

	getUserTrustedApps : function(scb, fcb) {
		var token = mypermissions_user.getToken();

		if (token && token != "") {
			var ts = Math.round((new Date()).getTime() / 1000);

		    var details = {
		    	url: mypermissions_urls.getAPIUrl("usertrustedapps", "_=" + ts),
				method: 'GET',
				async: true,
				contentType: 'json',
				headers : { "X-Token" : mypermissions_user.getToken() }
		    }

		    var self = this;
		    kango.xhr.send(details, function(data) {
		    	if(data.status == 200 && data.response != null) {
		    		var result = data.response;
					self._userTrustedApps = result.data;
					for (var i in self._userTrustedApps) {
						var ta = self._userTrustedApps[i];
						self._userTrustedAppsIndex[ta.appId] = ta;
					}

					if (scb) {
						scb();
					}
		    	} else {
		    		if (fcb) {
						fcb({ "result" : "failed", "data" : { "status" : data.status, "response" : data.response } });
					}
		    	}
		    });
		} else {
			if (scb) {
				scb(); // TODO: Consider handling failed cases better even though we don't require the token now
			}
		}
  	},

  	fetchFacebookUserDetails : function(cb) {  		
  		var self = this;

  		var details = {
	    	url: self._rootUrl, 
			method: 'GET',
			async: true,
			contentType: 'text'
		}

		var callback = cb;

		kango.xhr.send(details, function(data) {
			noData = true;
			if (data.status == 200 && data.response != null) {
				var userID = null;

				m = data.response.match('\"user_id\"\:([0-9]+)');
				if (m && m.length > 0) {
					userID = m[1];
				}

				if (userID == null) {
					m = data.response.match('\"userID\"\:\"([0-9]+)\"');
					if (m && m.length > 0) {
						userID = m[1];
					}
				}

				if (userID == null) {
					m = data.response.match('\<a class="inv" href="/(.*)\?refid\=(.*)" accesskey\=\"1\"\>Timeline\<\/a\>');
					if (m && m.length > 0) {
						userID = m[1].replace("?", "");
					}				
				}

				var foundUser = (userID && userID != "" && userID != "0");
				if (!foundUser) {
					userID = $(data.response).find("#m_user_DEPRECATED").val();
					foundUser = (userID && userID != "" && userID != "0");
				}

				if (foundUser) {
					self.track("BGFBSignedIn");

					kango.storage.setItem("fb_active_userid", userID);
					
					var details = {						
						url : "https://graph.facebook.com/" + userID,
						method : "GET",
						async : true,
						contentType : "json"
					}	

					kango.xhr.send(details, function(data) {						
						noData = true;

						if (data.status == 200 && data.response != null) {
							var icon = "https://graph.facebook.com/" + userID + "/picture";
							var name = data.response.name;
							
							kango.storage.setItem("fb_active_user_name", name);
							kango.storage.setItem("fb_active_user_icon", icon);

							if (callback) {
								noData = false;
								callback({ "name" : name, "icon" : icon });
							} 

							kango.browser.tabs.getCurrent(function(tab) {
								//self._postMessageToTab("MyPermissionsFacebookUserDetails", { "userId" : userID, "icon" : icon, "name" : name });
        						tab.dispatchMessage('MyPermissionsFacebookUserDetails', { "userId" : userID, "icon" : icon, "name" : name });
							});
						}

						if (noData) {
							if (callback) {
								kango.storage.removeItem("fb_active_userid");
								kango.storage.removeItem("fb_active_user_name");
								kango.storage.removeItem("fb_active_user_icon");
								callback(null);
							}
						}
					});
				} else {
					self.track("BGFBSignedOut");
					if (noData) {
						if (callback) {
							kango.storage.removeItem("fb_active_userid");
							kango.storage.removeItem("fb_active_user_name");
							kango.storage.removeItem("fb_active_user_icon");
							callback(null);
						}
					}
				}		
			}
		});
	},

	getActiveFacebookUserDetails : function() {
		var fbUserId = kango.storage.getItem("fb_active_userid");
		var fbUserName = kango.storage.getItem("fb_active_user_name");
		var fbUserIcon = kango.storage.getItem("fb_active_user_icon");

		return {
			"userId" : fbUserId,
			"name" : fbUserName,
			"icon" : fbUserIcon
		}
	},

	setActiveFacebookUserDetails : function(userId, name, icon) {
		kango.storage.setItem("fb_active_userid", userId);
		kango.storage.setItem("fb_active_user_name", name);
		kango.storage.setItem("fb_active_user_icon", icon);		
	},

	_getNewAppsKey : function(userID) {
		return "fb_new_apps_" + userID;
	},

	_getAppsCountKey : function(userID) {
		return "fb_" + userID + "_apps_count";
	},

	_getNewApps : function(userID) {
		if (userID && userID != "") {
			var self = this;
			var key = self._getNewAppsKey(userID);
			var data = kango.storage.getItem(key);
			if (data && data != "") {
				var t = JSON.parse(data);
				if (typeof(t) == "string") {
					t = JSON.parse(t);
				}

				return t;
			}
		}

		return null;
	},

	_getNewAppsCountKey : function(userID) {
		return "fb_" + userID + "_new_apps_count";
	},

	_setNewAppsCount : function(userID, value) {
		var self = this;
		self._setCounter(self._getNewAppsCountKey(userID), value);
	},

	_getAppsKey : function(userID) {
		return "fb_" + userID;	
	},

	_getApps : function(userID) {
		var self = this;
		var key = self._getAppsKey(userID);
		var data = kango.storage.getItem(key);
		if (data && data != "") {
			if (typeof(data) == "string") {
				data = JSON.parse(data);
				if (typeof(data) == "string") {
					data = JSON.parse(data);
				}
			}
			return data;
		} 

		return null;
	},

	_getAppsAsString : function(userID) {
		var self = this;
		var apps = self._getApps(userID);
		return JSON.stringify(apps);
	},

	_setCounter : function(counterName, value) {
		kango.storage.setItem(counterName, String(value));
	},

	_setAppsCount : function(userID, value) {
		var self = this;
		self._setCounter(self._getAppsCountKey(userID), value);
	},

	_saveNewApps : function(userID, new_apps) {
		var self = this;
		var key = self._getNewAppsKey(userID);
		kango.storage.setItem(key, JSON.stringify(new_apps));
	},

	_saveApps : function(userID, apps) {
		var self = this;
		var key = self._getAppsKey(userID);
		kango.storage.setItem(key, JSON.stringify(apps));
		self._setAppsCount(userID, apps.length);
	},

	_sendNotification : function(app) {
		//var clickUrl = mypermissions_urls.getServerUrl("/cleaner#!/apps/a" + a.id);

		var appData = JSON.stringify(app);
		
		var details = {
	        method: "POST",
	        url: mypermissions_urls.getAPIUrl("notify"),
	        async: true,
	        params: { "data" : encodeURIComponent(appData) },
	        headers: { "X-Token" : mypermissions_user.getToken(), "X-InstallId" : mypermissions_user.getInstallId() }
		};

		kango.xhr.send(details, function(data) {
	        
		});
	},

	_updateServerOnApps : function(apps) {
		var token = mypermissions_user.getToken();

		var appsToUpdate = new Array();
		var appsToUpdateCounter = 0;
		for (var i = 0; i < apps.length; i++) {
			if (apps[i].crawl) {
				appsToUpdate[appsToUpdateCounter] = apps[i];
				appsToUpdateCounter++;
			}
		}

		var details = {
	        method: "POST",
	        url: mypermissions_urls.getAPIUrl("updateapps"),
	        async: true,
	        params: { "apps" : encodeURIComponent(JSON.stringify(appsToUpdate)) },
	        headers: { "X-Token" : token }
		}; 	

		kango.xhr.send(details, function(data) {
	        
		});
	},

	_compareApps : function(userID, apps, reportProgress) {
		var self = this;
		var key = self._getAppsKey(userID);

		self._updateServerOnApps(apps);

		var newAppsCounter = 0;
		var appsKnowAddedDate = Math.round((new Date()).getTime() / 1000);

		var newApps = self._getNewApps(userID);
		if (!newApps) {
			newApps = new Array();
		}
		savedApps = self._getApps(userID);
		if (!savedApps) {
			self._saveApps(userID, apps);
		} else {
			for (var i in apps) {
				var a = apps[i];
				var foundApp = false;
				for (var j in savedApps) {
					var sa = savedApps[j];
					if (a.id == sa.id) {
						foundApp = true;
						a.knownAddedDate = sa.knownAddedDate;
						break;
					}
				}

				if (!foundApp) {
					a.notified = false;

					var newAppFound = false;
					for (var nai in newApps) {
						var na = newApps[nai];
						if (na.id == a.id) {
							newAppFound = true;
							break;
						}
					}

					if (!newAppFound) {
						newApps.push(a);
					}
					a.knownAddedDate = appsKnowAddedDate;
					newAppsCounter += 1;
				}
			}	
		}

		var isFirstTime = false;
		if (self.isFirstTime()) {
			self._setIsFirstTime("1");
			isFirstTime = true;
		} else {
			if (newAppsCounter > 0) {
				self._saveNewApps(userID, newApps);
				self._setNewAppsCount(userID, newAppsCounter);

				if (newApps.length > 0) {
					var badgeValue = 0;
					for (var i in newApps) {
						var a = newApps[i];
						if (!a.notified) {
							badgeValue += 1;
							var notificationText = "";
							notificationText = "'" + a.name + "' Facebook app can access your information. Please review it!";

							var iconUrl = null;
							if (typeof(safari) != 'undefined') {
								iconUrl = safari.extension.baseURI + "resources/icon48.png";
							} else if (typeof(chrome) != 'undefined') {
								iconUrl = chrome.extension.getURL("resources/icon48.png");
							} else {
								iconUrl = mypermissions_urls.getServerUrl("/static/img/icon48.png");
							}

							if (!reportProgress) {																
								self._sendNotification(a);
							}
						}
			        }

			        if (!reportProgress) {
						kango.ui.browserButton.setBadgeValue(badgeValue);
					}

			        self._saveNewApps(userID, newApps); 
			    }
			}
		}


		self._saveApps(userID, apps);

		var result = {
			status: "ok",
			statusCode : 200,
			userID : userID,
			name : self.name,
			newAppsCount : newAppsCounter,
			newAppsAddedDate : appsKnowAddedDate,
			isFirstTime : isFirstTime,
			apps: apps,
			newApps: newApps
		}

		kango.console.log(MyPermissions_FacebookCheck.name + ": Done");

		var progressCallbackData = {	
			name : self.name,
			state : "finish"
		}

		var progressDataString = JSON.stringify(progressCallbackData)

		if (reportProgress) {
			self._postMessageToTab("MyPermissionsScanProgress", progressDataString);
			/*kango.browser.tabs.getCurrent(function(tab){

				tab.dispatchMessage("MyPermissionsScanProgress", progressDataString);
			});*/
		} else {
			self.track("BGScanEnded");
		}

		self._inTheMiddleOfChecking = false;
		self._lastAutoCheckTime = null;
		self._lastManualCheckTime = null;
		self._currentTab = null;
	},

	_fetchAppsData : function(userID, apps, reportProgress) {
		var self = this;
		var appsToCheck = new Array()
		var appsToCheckCounter = 0;
		for (var i in apps) {
			if (apps[i].crawl) {
				appsToCheck[appsToCheckCounter] = apps[i];
				appsToCheckCounter++;
			}
		}

		var counter = 1;
		var requestsData = new Array();

		var totalApps = appsToCheck.length;
		var appsCompleted = 0;

		var noAppsToCheck = (appsToCheck.length == 0);

		while (appsToCheck.length > 0) {
			var app = appsToCheck.pop();
			var url = self._singleAppUrlTemplate + app.id + "&__user=" + userID;

			var details = {
		    	url: url,
				method: 'GET',
				async: true,
				contentType: 'text'				
			}

			kango.xhr.send(details, function(data) {
				if (data.status == 200 && data.response != null) {
					var appDOM = $(data.response);

					var appIdContainer = appDOM.find("#root div.acw a.btnD");
					if (!appIdContainer || appIdContainer.length == 0) {
						appIdContainer = appDOM.find("#title div.acw a.btnD");
					}

					var appId = null;
					if (!appIdContainer || appIdContainer.length == 0) {
						// Report scrape error
						return;
					} else {
						var m = appIdContainer.attr("href").match("id=([0-9]+)");
						if (m && m.length > 0) {
							appId = m[1];
						} 
					}

					kango.console.log("Got AppId=" + appId);

					var app = null;
					for (var i = 0; i < apps.length; i++) {
						if (apps[i].id == appId) {
							kango.console.log("found app id");
							app = apps[i];
							break;
						}
					}

					if (app == null) {
						// Report scrape error
						kango.console.log("Failed to find app with id=" + appId);
						return;
					}
					
					var items = appDOM.find("#root .item");
					if (items.length == 0) {
						items = appDOM.find("#objects_container div.abb");
					}

					var category = null;
					var permission_text = null;

					permissions = {}

					var canPostInYourName = false;
					var accessYourInfo = false;
					var knowYourLocation = false;
					var accessYourInboxOrContacts = false;
					var access247 = false;
					var accessContent = false;

					var i = 0;
					for (i = 0; i < items.length; i++) {
						var item = $(items[i]);
						category = item.parent().find(".al").text();
						if (category && category != "") {
							if (item.find(".right").length > 0) {
								permission_text = $(item.find(".primary")).text();
							} else if (item.find(".preview").length > 0) {
								permission_text = [$(item.find(".title")).text(), $(item.find(".preview")).text()];
							} else {
								if (item.find("span").length > 0) {
									permission_text = item.find("span").text();
								} else {
									permission_text = item.text();
								}
							}

							if (typeof(permissions[category]) == "undefined") {
								permissions[category] = [];
							}

							if (permission_text == "Post on my behalf") {
								canPostInYourName = true;
							} else if (permission_text == "Access my basic information") {
								accessYourInfo = true;
							} else if (permission_text == "Check-ins") {
								knowYourLocation = true;
							} else if (permission_text == "Access messages in my inbox") {
								accessYourInboxOrContacts = true;
							} else if (permission_text == "Access my data any time") {
								access247 = true;
							} else if (permission_text == "Access my content") {
								accessContent = true;
							}

							if (category == "Required" || category == "Other" || category == "Last data access") {
								//console.log(this.app.name + ": " + category + permission_text);
								permissions[category].push(permission_text);
							}
						}
					}

					app.lastDataAccess = null;

					app.filterValue = 0;
					app.permissions = permissions;
					app.canPostInYourName = canPostInYourName;
					app.accessYourInfo = accessYourInfo;
					app.knowYourLocation = knowYourLocation;
					app.accessYourInboxOrContacts = accessYourInboxOrContacts;
					app.access247 = access247;
					app.accessContent = accessContent;
					app.source = self.name;

					app.threatLevel = 3;

					if (canPostInYourName) {
						app.filterValue += 1;
					} 
					if (accessYourInfo) {
						app.filterValue += 2;
					}
					if (knowYourLocation) {
						app.filterValue += 4;
					}
					if (accessYourInboxOrContacts) {
						app.filterValue += 8;
					}
					if (access247) {
						app.filterValue += 16;
					} 
					if (accessContent) {
						app.filterValue += 32;
					}

					if (access247 || accessYourInboxOrContacts) {
						app.threatLevel = 3;
					} 

					if (accessYourInfo && !canPostInYourName && !knowYourLocation && !accessYourInboxOrContacts && !access247 && !accessContent) {
						app.threatLevel = 1;
					}

					appsCompleted++;
					var progressCallbackData = {
						name : MyPermissions_FacebookCheck.name,
						state : "fetch_app_progress",
						data : {
							total : apps.length,
							index : appsCompleted,
							app : app
						}
					}

					var progressDataString = JSON.stringify(progressCallbackData)

					if (reportProgress) {
						self._postMessageToTab("MyPermissionsScanProgress", progressDataString);
						/*kango.browser.tabs.getCurrent(function(tab){
							tab.dispatchMessage("MyPermissionsScanProgress", progressDataString);
						});*/
					}

					if (appsCompleted == totalApps) {
						self._compareApps(userID, apps, reportProgress);
					}					
				}
			});

			counter++;
		} 

		if (noAppsToCheck) {
			self._compareApps(userID, apps, reportProgress);
		}
	},

	_parseResult : function(data, reportProgress) {
		var self = this;
		var appDOM = $(data);
		var apps = new Array();
		var userID = null;
		var m = data.match('\"user_id\"\:([0-9]+)')
		if (m && m.length > 0) {
			userID = m[1];
		}

		if (userID == null || userID == "") {
			try {
				userID = appDOM.find("#m_user_DEPRECATED").val();
			} catch (e) {
				console.log(e);
			}
		}

		m = data.match('\"user_id\"\:([0-9]+)');
		if (m && m.length > 0) {
			userID = m[1];
		}

		m = data.match('\"userID\"\:\"([0-9]+)\"');
		if (m && m.length > 0) {
			userID = m[1];
		}		

		if (userID == null) {
			var t = appDOM.find("input[name='targetid']");
			if (t.length > 0) {
				userID = t.val();
			}
		}

		if (userID == null) {
			m = data.match('\<a class="inv" href="/(.*)\?refid\=(.*)" accesskey\=\"1\"\>Timeline\<\/a\>');
			if (m && m.length > 0) {
				userID = m[1].replace("?", "");
			}				
		}

		if (userID) {
			kango.storage.setItem("fb_active_userid", userID);

			kango.console.log("Facebook: got user ID=" + userID);
			var items = appDOM.find("#root div.item a"); 
			
			if (items.length == 0) {
				items = appDOM.find("#objects_container #title").next().find("div.acw:first").next().find("div.acw a");
			}

			for (var i = 0; i < items.length; i++) {
				var item = $(items[i]);
				var m = item.attr("href").match("id=([0-9]+)");
				var appId = null;
				if (m && m.length > 0) {
					appId = m[1];
				}

				if (appId) {
					var appIcon = item.find(".image img").attr("src");
					var appName = item.find(".content .title").text();
					if (appName == null || appName == "") {
						appName = item.text();
					}

					var appTrusted = (appId in self._trustedAppsIndex);
					var appUserTrusted = (appId in self._userTrustedAppsIndex);

					var a = {
						id : appId,
						icon: appIcon,
						name: appName,
						source : "Facebook",
						trusted: appTrusted,
						userTrusted: appUserTrusted
					}

					if (appTrusted) {
						a.certifiedUrl = self._trustedAppsIndex[appId].certifiedUrl;
					}

					apps.push(a);
				}
			}
			kango.console.log("Facebook: Got " + apps.length + " apps");

			var tempApps = new Array();
			for (i = 0; i < apps.length; i++) {
				tempApps.push(apps[i].id);
			}

			var details = {
		    	url: mypermissions_urls.getAPIUrl("crawlmanager"),
				method: 'POST',
				async: true,
				contentType: 'json',
				params: { "data" : encodeURIComponent(JSON.stringify({ "appIds" : tempApps })), "source" : "Facebook" },
	        	headers: { "X-Token" : mypermissions_user.getToken() }
			}

			kango.xhr.send(details, function(data) {
				if (data.status == 200 && data.response != null) {
					var missingApps = data.response.missingApps;
					var knownApps = data.response.knownApps;

					var i = 0;
					var j = 0;
					var k = 0;
					for (i = 0; i < missingApps.length; i++) {
						for (j = 0; j < apps.length; j++) {
							if (apps[j].id == missingApps[i]) {
								apps[j].crawl = true;
							}
						}					
					}

					for (i = 0; i < knownApps.length; i++) {
						for (j = 0; j < apps.length; j++) {
							if (apps[j].id == knownApps[i].id) {
								var app = apps[j];
								app.crawl = false;

								app.filterValue = 0;
								app.canPostInYourName = false;
								app.accessYourInfo = false;
								app.knowYourLocation = false;
								app.accessYourInboxOrContacts = false;
								app.access247 = false;
								app.accessContent = false;								

								app.permissions = knownApps[i].permissions;
								for (var category in app.permissions) {
									if (category == "Required" || category == "Other") {
										for (k = 0; k < app.permissions[category].length; k++) {
											var permission_text = app.permissions[category][k];
											if (permission_text == "Post on my behalf") {
												app.canPostInYourName = true;
												app.filterValue += 1;
											} else if (permission_text == "Access my basic information") {
												app.accessYourInfo = true;
												app.filterValue += 2;
											} else if (permission_text == "Check-ins") {
												app.knowYourLocation = true;
												app.filterValue += 4;
											} else if (permission_text == "Access messages in my inbox") {
												app.accessYourInboxOrContacts = true;
												app.filterValue += 8;
											} else if (permission_text == "Access my data any time") {
												app.access247 = true;
												app.filterValue += 16;
											} else if (permission_text == "Access my content") {
												app.accessContent = true;
												app.filterValue += 32;
											}
										}
									}
								}
							}
						}
					}

					self._fetchAppsData(userID, apps, reportProgress);					
				}
			});		
		} else {
			var result = {
				status: "fail",
				statusCode : 403,
				name : MyPermissions_FacebookCheck.name
			}

			var progressDataString = JSON.stringify(result)

			if (reportProgress) {
				self._postMessageToTab("MyPermissionsScanProgress", progressDataString);
				/*kango.browser.tabs.getCurrent(function(tab){
					tab.dispatchMessage("MyPermissionsScanProgress", progressDataString);
				});*/
			}
		}
	},

	_postMessageToTab : function(message, data) {
		var self = this;
		if (self._currentTab && self._currentTab != null) {
			self._currentTab.dispatchMessage(message, data);
		}
	},

	initiateSingleAutoCheck : function() {
		var self = this;

		self._autoCheckTimerId = setTimeout(function() {
			kango.console.log("Initiating single auto check");
			mypermissions_facebookcheck.check(false);			
		}, 60 * 1000 * 1); // 1min
	},

	startAutoCheck : function() {
		var self = this;

		self._autoCheckIntervalId = setInterval( function() {
			kango.console.log("Starting auto check");
			_lastAutoCheckTime = new Date();
			mypermissions_facebookcheck.check(false);
		}, 60 * 1000 * 30) // 45min
	},

	stopAutoCheck : function() {
		var self = this;
		clearInterval(self._autoCheckIntervalId);
	},

	track : function(name, params) {
		var details = {
	    	url: mypermissions_urls.getTrackUrl(name),
			method: "GET",
			async: true,
			headers : { "X-Token" : mypermissions_user.getToken() }
	    }

	    kango.xhr.send(details, function(data) {
	    });
	},

	check : function(reportProgress) {
		var self = this;

		if (self._inTheMiddleOfChecking) {
			var n = new Date();
			var autoCheckDiff = n - self._lastAutoCheckTime;
			var manualCheckDiff = n - self._lastManualCheckTime;
			if ((autoCheckDiff != null && autoCheckDiff > 1000 * 60 * 15) || (manualCheckDiff != null && manualCheckDiff > 1000 * 60 * 15)) {
				// If we are in the middle of a manual or auto scan more than 5min, release the lock and do the scan.
				self._inTheMiddleOfChecking = true;
				if (reportProgress) {
					self._lastManualCheckTime = new Date();
					self._lastAutoCheckTime = null;
				} else {
					self._lastAutoCheckTime = new Date();
					self._lastManualCheckTime = null;
				}				
			} else {
				return;
			}			
 		} else {
 			self._inTheMiddleOfChecking = true;
 		}

 		if (reportProgress) {
			self._lastManualCheckTime = new Date();
		
	 		kango.browser.tabs.getCurrent(function(tab){
	 			var url = tab.getUrl();
	 			if (url.indexOf("/cleaner") < 0) {
	 				kango.browser.tabs.getAll(function(tabs) {
        				for(var i = 0; i < tabs.length; i++){
                			url = tabs[i].getUrl();
                			if (url.indexOf("/cleaner") > 0) {
                				self._currentTab = tabs[i];
                				break;
                			}
        				}
					});
	 			} else {
					self._currentTab = tab;
				}
			});
 		} else {
 			self._currentTab = null;
 		}

		kango.console.log("Checking Facebook apps");

		self.getAllTrustedApps();
		self.getUserTrustedApps(function(data) {
			if (reportProgress) {
				var progressCallbackData = { 
					name: self.name, 
					state : "start", 
					data: null
				}
				var progressDataString = JSON.stringify(progressCallbackData)

				kango.console.log("Starting scan")
				self._postMessageToTab("MyPermissionsScanProgress", progressDataString);
				/*kango.browser.tabs.getCurrent(function(tab){
					
					tab.dispatchMessage("MyPermissionsScanProgress", progressDataString);					
				});*/
			} else {
				self.track("BGScanStarted");
			}

			self.fetchFacebookUserDetails(function(data) {
				if (data == null) {
					if (reportProgress) { 
						var progressData = { 
							name: self.name, 
							state : "noauth", 
							data: null
						}
						var progressDataString = JSON.stringify(progressData);

						self._postMessageToTab("MyPermissionsScanProgress", progressDataString);
						/*kango.browser.tabs.getCurrent(function(tab){
							tab.dispatchMessage("MyPermissionsScanProgress", progressDataString);						
						});*/
					}

					kango.console.log("Check finished. User not signed to Facebook");
					self._inTheMiddleOfChecking = false;
					self._lastManualCheckTime = null;
					self._lastAutoCheckTime = null;
					self._currentTab = null;
				} else {
					var details = {
				    	url: self._settingsUrl,
						method: 'GET',
						async: true,
						contentType: 'text'
					}

					kango.xhr.send(details, function(data) {
						if (data.status == 200 && data.response != null) {
							self._parseResult(data.response, reportProgress);
						}
					});
				}
			});
		}, null);		
  	},

  	getActiveUserId : function() {
  		return kango.storage.getItem("fb_active_userid");
  	},

  	saveAppsFromString : function(appsString) {
  		var self = this;
  		var activeUserId = self.getActiveUserId();
  		if (activeUserId != null && activeUserId != "") {
  			var apps = JSON.parse(appsString);
  			self._saveApps(activeUserId, apps);
  		}	
  	},

  	removeApp: function(appId) {
  		var self = this;  		
  		var removeUrl = self._removeUrlTemplate + appId;

  		var details1 = {
	    	url: removeUrl,
			method: 'GET',
			async: true,
			contentType: 'text'
		}

		kango.xhr.send(details1, function(data) {
			if (data.status == 200 && data.response != null) {
				var appDOM = $(data.response);
	  			var removeConfirmUrl = appDOM.find("#root .btnC").attr("href");
	  			removeConfirmUrl = "https://m.facebook.com" + removeConfirmUrl;

	  			var details2 = {
					url : removeConfirmUrl,
					method: 'GET',
					async: true,
					contentType: 'text'
	  			}

	  			kango.xhr.send(details2, function(data) {
	  				//self._postMessageToTab("MyPermissionsAppDeleted", JSON.stringify(data));
	  				kango.browser.tabs.getCurrent(function(tab) {
	  					var data = {
	  						"result" : "ok",
	  						"service" : self.name,
	  						"appId" : appId
	  					}

	  					var userId = self.getActiveUserId();
	  					var apps = self._getApps(userId);
	  					for (var i = 0; i < apps.length; i++) {
	  						if (apps[i].id == appId) {
	  							apps.splice(i, 1);
	  							self._saveApps(userId, apps);
	  							break;
	  						}
	  					}
	  					
						tab.dispatchMessage("MyPermissionsAppDeleted", JSON.stringify(data));
					});
	  			});
	  		} else {
	  			var data = {
	  				"result" : "fail",
					"service" : self.name,
					"appId" : appId
				}
				//self._postMessageToTab("MyPermissionsAppDeleted", JSON.stringify(data));
				kango.browser.tabs.getCurrent(function(tab) {
					tab.dispatchMessage("MyPermissionsAppDeleted", JSON.stringify(data));
				});
	  		}
		});
  	},

  	clearNewApps : function() {
  		var self = this;
  		var newAppsKey = self._getNewAppsKey(self.getActiveUserId());
  		kango.storage.removeItem(newAppsKey);
  		self._setNewAppsCount(self.getActiveUserId(), 0);
  	},

  	signOut : function() {
  		var self = this;
  		var details1 = {
	    	url: self._rootUrl,
			method: 'GET',
			async: true
		}

		kango.xhr.send(details1, function(data) {
			var logoutResult = "0";
			var logoutUrl = "";
			if (data.status == 200 && data.response != null) {
				var appDOM = $(data.response);
				logoutUrl = self._rootUrl + appDOM.find('.mSideMenu div[data-sigil="logout side-menu-persist marea"] a').attr("href");

				var details2 = {
			    	url: logoutUrl,
					method: 'GET',
					async: true				
				}

				kango.xhr.send(details2, function(data) {
					logoutResult = "1";
					self._postMessageToTab("MyPermissionsFacebookSignOut", logoutResult);
					/*kango.browser.tabs.getCurrent(function(tab) {  					
						
						//tab.dispatchMessage("MyPermissionsFacebookSignOut", logoutResult);
					});*/	
				})
			} else {
				self._postMessageToTab("MyPermissionsFacebookSignOut", logoutResult);				
				/*kango.browser.tabs.getCurrent(function(tab) {  	
					
					//tab.dispatchMessage("MyPermissionsFacebookSignOut", logoutResult);
				});*/
			}
		});
  	},

  	clearActiveScan : function() {
  		var self = this;
  		self._inTheMiddleOfChecking = false;
  		self._lastManualCheckTime = null;
  		self._lastAutoCheckTime = null;
  	},

  	setActiveScan : function(value) {
  		var self = this;
  		self._inTheMiddleOfChecking = value;
  	}
}

new MyPermissions_FacebookCheck();