﻿mypermissionscleanerextension = null;

if (kango.browser.getName() == "chrome") {
	function updatePageAction(tabId) {
		chrome.tabs.sendRequest(tabId, {is_content_script: true}, function(response) {
			if (response && typeof(response.is_content_script) != "undefined" && response.is_content_script) {
				chrome.pageAction.show(tabId);
			}
	    });
	};

	chrome.tabs.onUpdated.addListener(function(tabId, change, tab) {
		if (change.status == "complete") {
			if (tab.url.match(/facebook.com\/appcenter\/(.*)/g)) {
				updatePageAction(tabId);
			}
		}
	});
} 

function MyPermissionsCleanerExtension() {
	var self = this;
	kango.ui.browserButton.addEventListener(kango.ui.browserButton.event.Command, function(){self._onBrowserButtonClick();});
	mypermissionscleanerextension = self;

	kango.browser.addEventListener(kango.browser.event.BeforeNavigate, function(event) {		
		if (event.url.search("192.168.56.101:8888/cleaner|mypermissions.com/cleaner") > -1) {
			event.target.dispatchMessage('MyPermissionsUrlChange', event.url);
		} 
	});
}

MyPermissionsCleanerExtension.prototype = {
	_getResourceUrl : function(resource) {
		if (kango.browser.getName() == "firefox") {
			// The framework will replace kango with MyPermissions_kango
			return "chrome://kango/content/" + resource;
		} else {
			return resource;
		}
	},

	_onBrowserButtonClick: function() {
		var installedVersion = mypermissionscleanerextension.getInstalledVersion();
		var firstTime = false;

		if (installedVersion == null) {
			firstTime = true;
		} 
		
		var token = mypermissions_user.getToken();
		if ((token == null || token == "") && firstTime) {
			kango.browser.tabs.create( { url: mypermissions_urls.getServerUrl("/signup", "next=" + escape("/cleaner#!/settoken/__")) } );
		} else {
			kango.browser.tabs.create( { url: mypermissions_urls.getServerUrl("/cleaner#!/") } );
		}
	},

	getInstalledVersion : function() {
		return kango.storage.getItem("version");
	},

	setInstalledVersion : function() {
		var self = this;
		kango.storage.setItem("version", self.getVersion());
	},

	getVersion : function() {
		return kango.getExtensionInfo().version;
	}
};

new MyPermissionsCleanerExtension();